#ifndef CommandProcessor_First
#ifdef __GNUG__
//pragma once
#pragma interface
#endif
#define CommandProcessor_First

#include "Command.h"

//---- CommandProcessor --------------------------------------------------------

class CommandProcessor : public Object {
protected:
    int cap, changeCount;

    virtual void PerformNormalCommand(Command* cmd);
    virtual Command *GetAt(int i);
    virtual void FinishFrom(int n);
public:
    MetaDef(CommandProcessor);
    CommandProcessor();
    ~CommandProcessor();
    bool Modified()
	{ return changeCount > 0; }
    int Size()
	{ return cap; }
    void PerformCommand(Command* cmd);
    void DoCreateMenu(class Menu *menu);
    void DoSetupMenu(Menu *menu);
    void DoMenuCommand(int cmdId);
    void Finish();
};

//---- CommandProcessor --------------------------------------------------------

class CommandProcessor1 : public CommandProcessor {
protected:
    class Command *lastCmd;

    void PerformNormalCommand(Command* cmd);
    void FinishFrom(int n);
    Command *GetAt(int i);
public:
    MetaDef(CommandProcessor1);
    CommandProcessor1();
};

//---- CommandProcessorN -------------------------------------------------------

class CommandProcessorN : public CommandProcessor {
protected:
    class ObjArray *cmdHistory;

    ~CommandProcessorN();
    Command *GetAt(int i);
    void PerformNormalCommand(Command* cmd);
    void FinishFrom(int n);
public:
    MetaDef(CommandProcessorN);
    CommandProcessorN();
};

//---- CommandProcessor10 ------------------------------------------------------

class CommandProcessor10 : public CommandProcessor {
protected:
    Command **mem;
    int start, size;

    ~CommandProcessor10();
    Command *GetAt(int i);
    void PerformNormalCommand(Command* cmd);
    void FinishFrom(int n);
public:
    MetaDef(CommandProcessor10);
    CommandProcessor10(int s);
};

#endif

